# scripts

My personal collection of handy scripts. mostly bash.

- [restic_backup.sh](#restic_backup.sh)
- [setup_zsh.sh](#setup_zsh.sh)

## restic_backup.sh

> This script is my very simple take on how to perform restic backups.

First you need to download the script from this Git repository. I usually just put it in root's home.

```bash
# Download
sudo curl -o /root/restic_backup.sh https://git.socialnerds.org/david/scripts/raw/branch/main/restic_backup.sh
sudo chmod +x /root/restic_backup.sh
```

In the config section at the top of the script you can change various options to your liking.

```bash
# ****  CONFIG  ****
PASSWORD="/root/.restic-password"
REPO="sftp:<remote-server>:/path/to/repository"
KEEP=30
BIN="/usr/bin/restic" 
OPTIONS="-p $PASSWORD -r $REPO -q"
```

You can run `restic_backup.sh` directly from the command line

```bash
# Usage
/root/restic_backup.sh /local/path <additional flags for the backup subcommand>

# Example
/root/restic_backup.sh /home -x -e ./.snapshots
```

or using cron.

```bash
# Cronjob
47 0 * * * /root/restic_backup.sh /home

# Cronjob (with healthchecks notification)
47 0 * * * /root/restic_backup.sh /home && curl -fsS -m 10 --retry 5 -o /dev/null https://checks.socialnerds.org/ping/fb721aec-5179-42c3-3455-4fd2ff39ii55
```

Happy backuping! :-)

---

## setup_zsh.sh

> One-line installer for zsh, oh-my-zsh and various zsh plugins.

```bash
curl -fsSL https://socialg.it/david/scripts/raw/master/setup_zsh.sh | bash
```

It is still highly experimental and will probably fail on your system.
